import type { Booleanish, ColorVariant, TableField, TableFieldObject, TableItem, VerticalAlign } from '../../types';
declare const _sfc_main: import("vue").DefineComponent<{
    align: {
        type: null;
        required: false;
    };
    caption: {
        type: StringConstructor;
        required: false;
    };
    captionTop: {
        type: null;
        required: false;
        default: boolean;
    };
    borderless: {
        type: null;
        required: false;
        default: boolean;
    };
    bordered: {
        type: null;
        required: false;
        default: boolean;
    };
    borderVariant: {
        type: null;
        required: false;
    };
    dark: {
        type: null;
        required: false;
        default: boolean;
    };
    fields: {
        type: ArrayConstructor;
        required: false;
        default: () => never[];
    };
    footClone: {
        type: null;
        required: false;
        default: boolean;
    };
    hover: {
        type: null;
        required: false;
        default: boolean;
    };
    items: {
        type: ArrayConstructor;
        required: false;
        default: () => never[];
    };
    responsive: {
        type: (StringConstructor | BooleanConstructor)[];
        required: false;
        default: boolean;
    };
    small: {
        type: null;
        required: false;
        default: boolean;
    };
    striped: {
        type: null;
        required: false;
        default: boolean;
    };
    variant: {
        type: null;
        required: false;
    };
    sortBy: {
        type: StringConstructor;
        required: false;
    };
    sortDesc: {
        type: null;
        required: false;
        default: boolean;
    };
    sortInternal: {
        type: null;
        required: false;
        default: boolean;
    };
    selectable: {
        type: null;
        required: false;
        default: boolean;
    };
    stickySelect: {
        type: null;
        required: false;
        default: boolean;
    };
    selectHead: {
        type: (StringConstructor | BooleanConstructor)[];
        required: false;
        default: boolean;
    };
    selectMode: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    selectionVariant: {
        type: null;
        required: false;
        default: string;
    };
    stickyHeader: {
        type: null;
        required: false;
        default: boolean;
    };
    busy: {
        type: null;
        required: false;
        default: boolean;
    };
}, {
    props: {
        align?: VerticalAlign | undefined;
        caption?: string | undefined;
        captionTop: Booleanish;
        borderless: Booleanish;
        bordered: Booleanish;
        borderVariant?: ColorVariant | undefined;
        dark: Booleanish;
        fields: Array<TableField>;
        footClone: Booleanish;
        hover: Booleanish;
        items: Array<TableItem>;
        responsive: boolean | 'sm' | 'md' | 'lg' | 'xl' | 'xxl';
        small: Booleanish;
        striped: Booleanish;
        variant?: ColorVariant | undefined;
        sortBy?: string | undefined;
        sortDesc: Booleanish;
        sortInternal: Booleanish;
        selectable: Booleanish;
        stickySelect: Booleanish;
        selectHead: boolean | string;
        selectMode: 'multi' | 'single' | 'range';
        selectionVariant: ColorVariant;
        stickyHeader: Booleanish;
        busy: Booleanish;
    };
    captionTopBoolean: import("vue").ComputedRef<boolean>;
    borderlessBoolean: import("vue").ComputedRef<boolean>;
    borderedBoolean: import("vue").ComputedRef<boolean>;
    darkBoolean: import("vue").ComputedRef<boolean>;
    footCloneBoolean: import("vue").ComputedRef<boolean>;
    hoverBoolean: import("vue").ComputedRef<boolean>;
    smallBoolean: import("vue").ComputedRef<boolean>;
    stripedBoolean: import("vue").ComputedRef<boolean>;
    sortDescBoolean: import("vue").ComputedRef<boolean>;
    sortInternalBoolean: import("vue").ComputedRef<boolean>;
    selectableBoolean: import("vue").ComputedRef<boolean>;
    stickyHeaderBoolean: import("vue").ComputedRef<boolean>;
    stickySelectBoolean: import("vue").ComputedRef<boolean>;
    busyBoolean: import("vue").ComputedRef<boolean>;
    emits: {
        (e: 'headClicked', key: import("../../types/LiteralUnion").default<string, string>, field: TableField<Record<string, unknown>>, event: MouseEvent, isFooter: boolean): void;
        (e: 'rowClicked', item: TableItem<Record<string, unknown>>, index: number, event: MouseEvent): void;
        (e: 'rowDblClicked', item: TableItem<Record<string, unknown>>, index: number, event: MouseEvent): void;
        (e: 'rowHovered', item: TableItem<Record<string, unknown>>, index: number, event: MouseEvent): void;
        (e: 'rowUnhovered', item: TableItem<Record<string, unknown>>, index: number, event: MouseEvent): void;
        (e: 'rowSelected', value: TableItem): void;
        (e: 'rowUnselected', value: TableItem): void;
        (e: 'selection', value: TableItem[]): void;
        (e: 'update:sortBy', value: string): void;
        (e: 'update:sortDesc', value: boolean): void;
        (e: 'sorted', sortBy: string, isDesc: boolean): void;
    };
    slots: Readonly<{
        [name: string]: import("vue").Slot | undefined;
    }>;
    classes: import("vue").ComputedRef<(string | {
        [x: string]: boolean;
        'table-striped': boolean;
        'table-hover': boolean;
        'table-dark': boolean;
        'table-bordered': boolean;
        'table-borderless': boolean;
        'table-sm': boolean;
        'caption-top': boolean;
        'b-table-selectable': boolean;
        'b-table-selecting user-select-none': boolean;
        'b-table-busy': boolean;
    })[]>;
    itemHelper: {
        normaliseFields: (origFields: TableField<Record<string, unknown>>[], items: TableItem<Record<string, unknown>>[]) => TableFieldObject<Record<string, unknown>>[];
        sortItems: (fields: TableField<Record<string, unknown>>[], items: TableItem<Record<string, any>>[], sort?: {
            key?: string | undefined;
            desc?: boolean | undefined;
        } | undefined) => TableItem<Record<string, any>>[];
    };
    computedFields: import("vue").ComputedRef<TableFieldObject<Record<string, unknown>>[]>;
    computedFieldsTotal: import("vue").ComputedRef<number>;
    computedItems: import("vue").ComputedRef<TableItem<Record<string, unknown>>[]>;
    responsiveClasses: import("vue").ComputedRef<{
        [x: string]: boolean;
        'table-responsive': boolean;
        'b-table-sticky-header': boolean;
    }>;
    getFieldHeadLabel: (field: TableField) => string;
    headerClicked: (field: TableField, event: MouseEvent, isFooter?: boolean) => void;
    onRowClick: (row: TableItem, index: number, e: MouseEvent) => void;
    onRowDblClick: (row: TableItem, index: number, e: MouseEvent) => void;
    onRowMouseEnter: (row: TableItem, index: number, e: MouseEvent) => void;
    onRowMouseLeave: (row: TableItem, index: number, e: MouseEvent) => void;
    addSelectableCell: import("vue").ComputedRef<boolean>;
    isSortable: import("vue").ComputedRef<boolean>;
    handleFieldSorting: (field: TableField) => void;
    selectedItems: import("vue").Ref<Set<TableItem<Record<string, unknown>>>>;
    isSelecting: import("vue").ComputedRef<boolean>;
    notifySelectionEvent: () => void;
    handleRowSelection: (row: TableItem, index: number, shiftClicked?: boolean) => void;
    toggleRowDetails: (tr: TableItem) => void;
    getFieldColumnClasses: (field: TableFieldObject) => (string | string[] | {
        'b-table-sortable-column': boolean | undefined;
        'b-table-sticky-column': boolean | undefined;
    } | undefined)[];
    getFieldRowClasses: (field: TableFieldObject, tr: TableItem) => (string | string[] | {
        'b-table-sticky-column': boolean | undefined;
    } | undefined)[];
    getRowClasses: (item: TableItem) => (string | null)[];
    selectAllRows: () => void;
    clearSelected: () => void;
    selectRow: (index: number) => void;
    unselectRow: (index: number) => void;
    BSpinner: import("vue").DefineComponent<{
        label: {
            type: StringConstructor;
            required: false;
        };
        role: {
            type: StringConstructor;
            required: false;
            default: string;
        };
        small: {
            type: null;
            required: false;
            default: boolean;
        };
        tag: {
            type: StringConstructor;
            required: false;
            default: string;
        };
        type: {
            type: null;
            required: false;
            default: string;
        };
        variant: {
            type: null;
            required: false;
        };
    }, {
        props: {
            label?: string | undefined;
            role: string;
            small: Booleanish;
            tag: string;
            type: import("../../types/SpinnerType").default;
            variant?: ColorVariant | undefined;
        };
        smallBoolean: import("vue").ComputedRef<boolean>;
        classes: import("vue").ComputedRef<{
            [x: string]: boolean;
            'spinner-border': boolean;
            'spinner-border-sm': boolean;
            'spinner-grow': boolean;
            'spinner-grow-sm': boolean;
        }>;
    }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        label: {
            type: StringConstructor;
            required: false;
        };
        role: {
            type: StringConstructor;
            required: false;
            default: string;
        };
        small: {
            type: null;
            required: false;
            default: boolean;
        };
        tag: {
            type: StringConstructor;
            required: false;
            default: string;
        };
        type: {
            type: null;
            required: false;
            default: string;
        };
        variant: {
            type: null;
            required: false;
        };
    }>>, {
        small: any;
        type: any;
        tag: string;
        role: string;
    }>;
    BTableContainer: import("vue").DefineComponent<{
        responsive: {
            type: (StringConstructor | BooleanConstructor)[];
            required: false;
            default: boolean;
        };
        responsiveClass: {
            type: null;
            required: false;
        };
    }, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        responsive: {
            type: (StringConstructor | BooleanConstructor)[];
            required: false;
            default: boolean;
        };
        responsiveClass: {
            type: null;
            required: false;
        };
    }>>, {
        responsive: string | boolean;
    }>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("headClicked" | "rowClicked" | "rowDblClicked" | "rowHovered" | "rowUnhovered" | "rowSelected" | "rowUnselected" | "selection" | "update:sortBy" | "update:sortDesc" | "sorted")[], "headClicked" | "rowClicked" | "rowDblClicked" | "rowHovered" | "rowUnhovered" | "rowSelected" | "rowUnselected" | "selection" | "update:sortBy" | "update:sortDesc" | "sorted", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    align: {
        type: null;
        required: false;
    };
    caption: {
        type: StringConstructor;
        required: false;
    };
    captionTop: {
        type: null;
        required: false;
        default: boolean;
    };
    borderless: {
        type: null;
        required: false;
        default: boolean;
    };
    bordered: {
        type: null;
        required: false;
        default: boolean;
    };
    borderVariant: {
        type: null;
        required: false;
    };
    dark: {
        type: null;
        required: false;
        default: boolean;
    };
    fields: {
        type: ArrayConstructor;
        required: false;
        default: () => never[];
    };
    footClone: {
        type: null;
        required: false;
        default: boolean;
    };
    hover: {
        type: null;
        required: false;
        default: boolean;
    };
    items: {
        type: ArrayConstructor;
        required: false;
        default: () => never[];
    };
    responsive: {
        type: (StringConstructor | BooleanConstructor)[];
        required: false;
        default: boolean;
    };
    small: {
        type: null;
        required: false;
        default: boolean;
    };
    striped: {
        type: null;
        required: false;
        default: boolean;
    };
    variant: {
        type: null;
        required: false;
    };
    sortBy: {
        type: StringConstructor;
        required: false;
    };
    sortDesc: {
        type: null;
        required: false;
        default: boolean;
    };
    sortInternal: {
        type: null;
        required: false;
        default: boolean;
    };
    selectable: {
        type: null;
        required: false;
        default: boolean;
    };
    stickySelect: {
        type: null;
        required: false;
        default: boolean;
    };
    selectHead: {
        type: (StringConstructor | BooleanConstructor)[];
        required: false;
        default: boolean;
    };
    selectMode: {
        type: StringConstructor;
        required: false;
        default: string;
    };
    selectionVariant: {
        type: null;
        required: false;
        default: string;
    };
    stickyHeader: {
        type: null;
        required: false;
        default: boolean;
    };
    busy: {
        type: null;
        required: false;
        default: boolean;
    };
}>> & {
    onHeadClicked?: ((...args: any[]) => any) | undefined;
    onRowClicked?: ((...args: any[]) => any) | undefined;
    onRowDblClicked?: ((...args: any[]) => any) | undefined;
    onRowHovered?: ((...args: any[]) => any) | undefined;
    onRowUnhovered?: ((...args: any[]) => any) | undefined;
    onRowSelected?: ((...args: any[]) => any) | undefined;
    onRowUnselected?: ((...args: any[]) => any) | undefined;
    onSelection?: ((...args: any[]) => any) | undefined;
    "onUpdate:sortBy"?: ((...args: any[]) => any) | undefined;
    "onUpdate:sortDesc"?: ((...args: any[]) => any) | undefined;
    onSorted?: ((...args: any[]) => any) | undefined;
}, {
    small: any;
    dark: any;
    items: unknown[];
    busy: any;
    hover: any;
    striped: any;
    bordered: any;
    borderless: any;
    captionTop: any;
    responsive: string | boolean;
    fields: unknown[];
    footClone: any;
    sortDesc: any;
    sortInternal: any;
    selectable: any;
    stickySelect: any;
    selectHead: string | boolean;
    selectMode: string;
    selectionVariant: any;
    stickyHeader: any;
}>;
export default _sfc_main;
